
var STATUSBAR_PANEL_ID = "BOINC-Stats-statusbar-panel";

// BOINC Stats page URL.
var BOI_URL = "http://boinc.netsoft-online.com/get_user.php?cpid=";
var BURP_URL = "http://burp.boinc.dk/show_user.php?userid=";
var C960_URL = "http://www.chess960athome.org/alpha/show_user.php?userid=";
var CCHG_URL = "http://bbc.cpdn.org/show_user.php?userid=";
var CLIM_URL = "http://climateapps2.oucs.ox.ac.uk/cpdnboinc/show_user.php?userid=";
var EIN_URL = "http://einstein.phys.uwm.edu/show_user.php?userid=";
var HCL_URL = "http://boinc.banaan.org/hashclash/show_user.php?userid=";
var LEI_URL = "http://boinc.gorlaeus.net/show_user.php?userid=";
var LHA_URL = "http://lhcathome-alpha.cern.ch/show_user.php?userid=";
var LHC_URL = "http://lhcathome.cern.ch/show_user.php?userid=";
var MCN_URL = "http://www.malariacontrol.net/show_user.php?userid=";
var ORB_URL = "http://orbit.psi.edu/show_user.php?userid=";
var PIR_URL = "http://pirates.spy-hill.net/show_user.php?userid=";
var PRED_URL = "http://predictor1.scripps.edu/show_user.php?userid=";
var PRGR_URL = "http://www.primegrid.com/orig/show_user.php?userid=";
var QMC_URL = "http://qah.uni-muenster.de/show_user.php?userid=";
var RAL_URL = "http://ralph.bakerlab.org/show_user.php?userid=";
var RCN_URL = "http://dist.ist.tugraz.at/cape5/show_user.php?userid=";
var RIE_URL = "http://boinc.rieselsieve.com/orig/show_user.php?userid=";
var ROS_URL = "http://boinc.bakerlab.org/rosetta/show_user.php?userid=";
var SATR_URL = "http://attribution.cpdn.org/show_user.php?userid=";
var SAH_URL = "http://setiweb.ssl.berkeley.edu/show_user.php?userid=";
var SBP_URL = "http://setiweb.ssl.berkeley.edu/beta/show_user.php?userid=";
var SMP_URL = "http://boinc.bio.wzw.tum.de/boincsimap/show_user.php?userid=";
var SPH_URL = "http://spin.fh-bielefeld.de/show_user.php?userid=";
var SZDG_URL = "http://szdg.lpds.sztaki.hu/szdg/show_user.php?userid=";
var TAN_URL = "http://issofty17.is.noda.tus.ac.jp/show_user.php?userid=";
var UFL_URL = "http://www.ufluids.net/show_user.php?userid=";
var WCG_URL = "http://www.worldcommunitygrid.org/boinc/show_user.php?userid=";
var XTL_URL = "http://xw01.lri.fr:4320/show_user.php?userid=";

// One hour in ticks.  Used as the basis for the Update Frequency.
var ONE_HOUR = 3600000;

// Two hours is the default.
var MINIMUM_FREQUENCY = 1.0;

var coreDocument = document;
var coreWindow = window;
var statusBar = document.getElementById(STATUSBAR_PANEL_ID);

// The Http Request used to retrieve the current statistics.
var gXMLHttpRequest;
var project; // project we're currently checking
/*
	Load the users current statistics.
*/
init();
function init()
{
myproj = new projects();
	for (var proj in myproj)
	{
		if(getBOINCAccountNumber(myproj[proj]))
		{
		switcher(myproj[proj]);
		return;
		}
	}
	if(!project)
		project="seti";
}
function projects()
{
	this.aa = "boinc";
	this.ba = "burp";
	this.bb = "chess960";
	this.bc = "cchange";
	this.bd = "climate";
	this.be = "einstein";
	this.bf = "hashclash";
	this.bg = "leiden";
	this.bh = "lhcalpha";
	this.bi = "lhcathome";
	this.bj = "malaria";
	this.bk = "orbit";
	this.bl = "pirates";
	this.bm = "predictor";
	this.bn = "prime";
	this.bo = "qmcah";
	this.bp = "ralph";
	this.bq = "rcnumber";
	this.br = "riesieve";
	this.bs = "rosetta"
	this.bt = "season";
	this.bu = "seti";
	this.bv = "setibeta";
	this.bw = "simap";
	this.bx = "spinhenge";
	this.by = "sztaki";
	this.bz = "tanpaku";
	this.ca = "ufluids";
	this.cb = "wcgorg";
	this.cc = "xtrem";
}
function BOINC_url(project)
{
if (project == "boinc")
	return BOI_URL;
if (project == "burp")
	return BURP_URL;
if (project == "chess960")
	return C960_URL;
if (project == "cchange")
	return CCHG_URL;
if (project == "climate")
	return CLIM_URL;
if (project == "einstein")
	return EIN_URL;
if (project == "hashclash")
	return HCL_URL;
if (project == "leiden")
	return LEI_URL;
if (project == "lhcalpha")
	return LHA_URL;
if (project == "lhcathome")
	return LHC_URL;
if (project == "malaria")
	return MCN_URL;
if (project == "orbit")
	return ORB_URL;
if (project == "pirates")
	return PIR_URL;
if (project == "predictor")
	return PRED_URL;
if (project == "prime")
	return PRGR_URL;
if (project == "qmcah")
	return QMC_URL;
if (project == "ralph")
	return RAL_URL;
if (project == "rcnumber")
	return RCN_URL;
if (project == "riesieve")
	return RIE_URL;
if (project == "rosetta")
	return ROS_URL;
if (project == "season")
	return SATR_URL;
if (project == "seti")
	return SAH_URL;
if (project == "setibeta")
	return SBP_URL;
if (project == "simap")
	return SMP_URL;
if (project == "spinhenge")
	return SPH_URL;
if (project == "sztaki")
	return SZDG_URL;
if (project == "tanpaku")
	return TAN_URL;
if (project == "ufluids")
	return UFL_URL;
if (project == "wcgorg")
	return WCG_URL;
if (project == "xtrem")
	return XTL_URL;
return "";
}

function loadBOINCstats() 
{
	var accountNumber = getBOINCAccountNumber(project);
  
	if (accountNumber)
	{
		gXMLHttpRequest = new XMLHttpRequest();
		gXMLHttpRequest.onload = updateBOINCstats;
		gXMLHttpRequest.open("GET", BOINC_url(project) + accountNumber + "&format=xml");
		gXMLHttpRequest.send(null);
	}
	else
	{
		clearStatusBar();
	}
}

/*
	Loads the users current statistics, and schedules the next update.
*/
function loadAndSchedule()
{
	loadBOINCstats();
	
	scheduleNextCheck();
}

// At startup, get the current statistics.
window.setTimeout(loadAndSchedule, 3000);

/*
	Update the statusbar panel with the current statistics.
*/
function updateBOINCstats()
{
	try
	{
		// Did we get a "good" response from the server?
		if (200 == gXMLHttpRequest.status)
		{
			//java.awt.Toolkit.getDefaultToolkit().beep();
			
			var display = getBOINCDisplay();
			
			var totalCredit;
			var averageCredit;
			
			var regExp;
			var parsed;
			var hilfpos;
			var hilfmod;
			var tempstring;
			
			if (display == "both" || display == "total")
			{
				regExp = new RegExp("<total_credit>([0-9,]*.[0-9]*)<\/total_credit>");
       
       	        		parsed = regExp.exec(gXMLHttpRequest.responseText);
     	
                		totalCredit = String(Math.round(parseFloat(parsed[1])*100));
	
				hilfpos = totalCredit.substr(totalCredit.length-2);
				totalCredit=totalCredit.substr(0,totalCredit.length-2);
				hilfmod = totalCredit.length % 3;
				if (hilfmod==0 && totalCredit.length>=3 && totalCredit!=0)
				{
					hilfmod=3;
				}
				tempstring = totalCredit.substr(0,hilfmod);
				totalCredit = totalCredit.substr(hilfmod);
				while(totalCredit.length>0)
				{
					tempstring = tempstring + "," + totalCredit.substr(0,3);
					totalCredit = totalCredit.substr(3);
				}
				totalCredit = tempstring + "." + hilfpos;

			}
			
			if (display == "both" || display == "average")
			{
				regExp = new RegExp("<expavg_credit>([0-9,]*.[0-9]*)<\/expavg_credit>");

				parsed = regExp.exec(gXMLHttpRequest.responseText);
	  
				averageCredit = String(Math.round(parseFloat(parsed[1])*100));

		                hilfpos = averageCredit.substr(averageCredit.length-2);
				averageCredit=averageCredit.substr(0,averageCredit.length-2);
				hilfmod = averageCredit.length % 3;
				if (hilfmod==0 && averageCredit.length>=3 && averageCredit!=0)
				{
					hilfmod=3;
				}
				tempstring = averageCredit.substr(0,hilfmod);
				averageCredit = averageCredit.substr(hilfmod);
				while(averageCredit.length>0)
				{
					tempstring = tempstring + "," + averageCredit.substr(0,3);
					averageCredit = averageCredit.substr(3);
				}
				averageCredit = tempstring + "." + hilfpos;
			}

			setStatusBar(totalCredit, averageCredit);
			if(getBOINCprojicon())
			{
				var item = document.getElementById("stim");
				item.src = "chrome://boincstats/skin/little/" + img_func(project);
				item.setAttribute("tooltiptext", label(project));
				item.hidden = false;
			}
			else
			 	document.getElementById("stim").hidden = true;		}	
		else
		{
			noDataStatusBar(null);
		}
	}
	catch (err)
	{
        noDataStatusBar(err);
	}
}

/*
 	Schedule the next update.
*/
function scheduleNextCheck()
{
	var frequency = ONE_HOUR * getBOINCUpdateFrequency();

	coreWindow.setTimeout(loadAndSchedule, frequency);
}

/*
	Indicates there's no data available via the statusbar.
*/
function noDataStatusBar(error_code)
{
    var statusBar = getStatusBar();
   
    if (statusBar)
    {
        if (error_code != null)
        {
            statusBar.setAttribute(
                "tooltiptext",
                "Error: " + error_code);
        }
        else
        {
            statusBar.setAttribute(
                "tooltiptext",
                label(project)+" User Stats data is currently unavailable");
        }
        statusBar.label = "Data Unavailable";
    }
}
/*
	Clears the statusbar.
*/
function clearStatusBar()
{
	var statusBar = getStatusBar();
	
	if (statusBar)
	{
		statusBar.setAttribute(
			"tooltiptext",
			"Please set your "+label(project)+"Account Number");
		statusBar.label = "Account Number Not Set";
	}
}


function setStatusBar(totalCredit, averageCredit)
{
	var statusBar = getStatusBar();
	
	if (statusBar)
	{
		var tooltipText = "";
		var labelText = "";
				
		if (totalCredit)
		{
            tooltipText = "Total Credits is " + totalCredit;
            labelText = totalCredit;
		}
		
		if (averageCredit)
		{
			if (totalCredit)
			{
				tooltipText += " / ";
				labelText += "/";
			}
			
            tooltipText += "Recent Average Credits is " + averageCredit;
            labelText += averageCredit;
		}

		var timeFormat = "h:mma";
		if (getBOINCTimeFormat24hr())
		{
			timeFormat = "H:mm";
		}
		
		tooltipText += " as of " + formatDate(new Date(), timeFormat).toLowerCase();
		statusBar.setAttribute(
			"tooltiptext", 
			tooltipText);
		statusBar.label = labelText;
	}
}

function getStatusBar()
{
	if (!statusBar)
	{
		var mainWindow = coreDocument.getElementById("main-window");

		if (mainWindow)
		{
			statusBar = mainWindow.ownerDocument.getElementById(STATUSBAR_PANEL_ID);
		}
	}
	
	return statusBar;
}

function getBOINCUserPage()
{
	var accountNumber = getBOINCAccountNumber(project);
  
	if (accountNumber)
	{
		var url = BOINC_url(project) + accountNumber + "&html=1";
	    var newTab = window.getBrowser().addTab(url);
	    window.getBrowser().selectedTab = newTab;
	}
}

function getBOINCAccountNumber(project)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    	getService(Components.interfaces.nsIPrefBranch);

	var accountNumber;

	if (prefs.getPrefType("boincstats.accountNumber" + project) == prefs.PREF_STRING)
		accountNumber = prefs.getCharPref("boincstats.accountNumber" + project);

	return accountNumber;
}

function setBOINCAccountNumber(accountNumber, project)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

	prefs.setCharPref("boincstats.accountNumber" + project, accountNumber);
}

function getBOINCUpdateFrequency()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    	getService(Components.interfaces.nsIPrefBranch);

	var frequency;

	if (prefs.getPrefType("boincstats.updateFrequency") == prefs.PREF_STRING)
		frequency = prefs.getCharPref("boincstats.updateFrequency");

	if (!frequency || frequency < MINIMUM_FREQUENCY)
	{
		frequency = MINIMUM_FREQUENCY;
	}

	return frequency;
}

function setBOINCUpdateFrequency(frequency)
{
	if (!frequency || frequency < MINIMUM_FREQUENCY)
	{
		window.alert("Update Frequency is too low.  Minimum is " + MINIMUM_FREQUENCY + ".");
		return false;
	}
		
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

	prefs.setCharPref("boincstats.updateFrequency", frequency);
	
	// Make sure the event fires on the new schedule ASAP.
	window.setTimeout(loadAndSchedule, 3000);
	//scheduleNextCheck();
	
	return true;
}

function getBOINCDisplay()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    	getService(Components.interfaces.nsIPrefBranch);

	var display;

	if (prefs.getPrefType("boincstats.display") == prefs.PREF_STRING)
		display = prefs.getCharPref("boincstats.display");

	if (!display)
	{
		display = "both";
	}

	return display;
}

function setBOINCDisplay(display)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

	prefs.setCharPref("boincstats.display", display);
}

function getBOINCTimeFormat24hr()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    	getService(Components.interfaces.nsIPrefBranch);

	var timeFormat24hr = false;

	if (prefs.getPrefType("boincstats.timeFormat24hr") == prefs.PREF_BOOL)
		timeFormat24hr = prefs.getBoolPref("boincstats.timeFormat24hr");

	return timeFormat24hr;
}

function setBOINCTimeFormat24hr(timeFormat24hr)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

	prefs.setBoolPref("boincstats.timeFormat24hr", timeFormat24hr);
}
function getBOINCprojicon()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    	getService(Components.interfaces.nsIPrefBranch);

	var projicon = false;

	if (prefs.getPrefType("boincstats.ProjectIcon") == prefs.PREF_BOOL)
		projicon = prefs.getBoolPref("boincstats.ProjectIcon");

	return projicon;
}

function setBOINCprojicon(projicon)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);

	prefs.setBoolPref("boincstats.ProjectIcon", projicon);
}
function label(project)
{
	switch(project)
	{
		case "boinc":
			return("BOINC User Total");
			break;
		case "burp":
			return("BURP");
			break;
		case "chess960":
			return("Chess960");
			break;
		case "cchange":
			return("Climate Change");
			break;
		case "climate":
			return("ClimatePrediction");
			break;
		case "einstein":
			return("Einstein@Home");
			break;
		case "hashclash":
			return("HashClash");
			break;
		case "leiden":
			return("Leiden Classical");
			break;
		case "lhcalpha":
			return("LHC Alpha");
			break;
		case "lhcathome":
			return("LHC@Home");
			break;
		case "malaria":
			return("MalariaControl");
			break;
		case "orbit":
			return("Orbit@Home");
			break;
		case "pirates":
			return("Pirates@Home");
			break;
		case "predictor":
			return("Predictor@Home");
			break;
		case "prime":
			return("Prime Grid");
			break;
		case "qmcah":
			return("QMC@Home");
			break;
		case "ralph":
			return("RALPH");
			break;
		case "rcnumber":
			return("Rectilinear Crossing Number");
			break;
		case "riesieve":
			return("RieselSieve");
			break;
		case "rosetta":
			return("Rosetta@Home");
			break;
		case "season":
			return("Seasonal Attribution");
			break;
		case "seti":
			return("SETI@Home");
			break;
		case "setibeta":
			return("SETIbeta/Astropulse");
			break;
		case "simap":
			return("SIMAP");
			break;
		case "spinhenge":
			return("Spinhenge@Home");
			break;
		case "sztaki":
			return("SZTAKI Desktop Grid");
			break;
		case "tanpaku":
			return("TANPAKU");
			break;
		case "ufluids":
			return("uFluids@Home");
			break;
		case "wcgorg":
			return("World Community Grid");
			break;
		case "xtrem":
			return("XtremLab");
			break;
	}
}
function populateMenu()
{	
	var boinc_menu = document.getElementById("boinc_popup");
	var childs = boinc_menu.childNodes;
	var item;
	while(boinc_menu.hasChildNodes())
		boinc_menu.removeChild(boinc_menu.firstChild);
	//for (var x = 0; x < childs.length; x++)
	// boinc_menu.removeChild(childs[x]);
	myproj = new projects();
	for (var proj in myproj)
	{
		if(getBOINCAccountNumber(myproj[proj]))
		{
		item = document.createElement("menuitem");
		item.setAttribute("label", label(myproj[proj]));
		item.setAttribute("id", myproj[proj]+"s");
		item.setAttribute("name", "sr");
		item.setAttribute("oncommand", "switcher(\""+myproj[proj]+"\")"); 
		item.setAttribute("type", "radio"); 
		if (!project)
		 {
		  project = myproj[proj];
		  item.setAttribute("checked","true");
		 }
		else
		  if(project == myproj[proj]) item.setAttribute("checked", "true");
		boinc_menu.appendChild(item);
		}
	}
}
function img_func(project)
{
	switch(project)
	{
		case "boinc":
			return("boi.png");
			break;
		case "burp":
			return("brp.png");
			break;
		case "chess960":
			return("960.png");
			break;
		case "cchange":
			return("cch.png");
			break;
		case "climate":
			return("cpn.png");
			break;
		case "einstein":
			return("ein.png");
			break;
		case "hashclash":
			return("hcl.png");
			break;
		case "leiden":
			return("lei.png");
			break;
		case "lhcalpha":
			return("lha.png");
			break;
		case "lhcathome":
			return("lhc.png");
			break;
		case "malaria":
			return("mcn.png");
			break;
		case "orbit":
			return("orb.png");
			break;
		case "pirates":
			return("pir.png");
			break;
		case "predictor":
			return("pre.png");
			break;
		case "prime":
			return("pgr.png");
			break;
		case "qmcah":
			return("qmc.png");
			break;
		case "ralph":
			return("ral.png");
			break;
		case "rcnumber":
			return("rcn.png");
		case "riesieve":
			return("rie.png");
			break;
		case "rosetta":
			return("ros.png");
			break;
		case "season":
			return("sea.png");
			break;
		case "seti":
			return("sah.png");
			break;
		case "setibeta":
			return("sbp.png");
			break;
		case "simap":
			return("smp.png");
			break;
		case "spinhenge":
			return("sph.png");
			break;
		case "sztaki":
			return("sdg.png");
			break;
		case "tanpaku":
			return("tan.png");
			break;
		case "ufluids":
			return("ufl.png");
			break;
		case "wcgorg":
			return("wcg.png");
			break;
		case "xtrem":
			return("xtl.png");
			break;
	}
}
function switcher(new_project)
{
	if (new_project != project)
	{
	project = new_project;
	loadAndSchedule();
	}
}
function panelClick(event)
{
	if (event && event.button == 0)
	{
		getBOINCUserPage();
	}
	else
	{
		loadBOINCstats();
	}
}

const setiPrefListener =
{
   domains: [ "boincstats.accountNumber",
              "boincstats.display",
              "boincstats.updateFrequency",
              "boincstatus.timeFormat24hr" ],

   observe: function(subject, topic, aPrefString) 
   {
     // Is this a pref change?
     if (topic != "nsPref:changed")
       return;

     loadAndSchedule();
   }
};

function addPrefListener(observer)
{
   var domains = ("domains" in observer) ? observer.domains : [observer.domain];

   try 
   {
	 var pref = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);
   
     var prefBranchInternal = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
     
     for (var i = 0; i < domains.length; i++) 
     {
       prefBranchInternal.addObserver(domains[i], observer, false);
     }

   } 
   catch(ex) 
   {
     dump(ex);//"Failed to observe pref: " + domains[i] + "\n");
   }
}

// Add the listener for our preferences.
addPrefListener(setiPrefListener);

function formatNumber(number)
{
	return addSeparatorsNF(number, ".", ".", ",");
}

/*
	Formats numbers nicely.
	
	From http://www.mredkj.com/javascript/nfbasic.html
*/
function addSeparatorsNF(nStr, inD, outD, sep)
{
	nStr += '';
	var dpos = nStr.indexOf(inD);
	var nStrEnd = '';
	if (dpos != -1) {
		nStrEnd = outD + nStr.substring(dpos + 1, nStr.length);
		nStr = nStr.substring(0, dpos);
	}
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(nStr)) {
		nStr = nStr.replace(rgx, '$1' + sep + '$2');
	}
	return nStr + nStrEnd;
}

/*
	Tests for the <code>value</code> to be a number.
*/
function isNumber(value)
{
	return true;
}

var MONTH_NAMES=new Array('January','February','March','April','May','June','July','August','September','October','November','December','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');var DAY_NAMES=new Array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sun','Mon','Tue','Wed','Thu','Fri','Sat');
function LZ(x){return(x<0||x>9?"":"0")+x}
function isDate(val,format){var date=getDateFromFormat(val,format);if(date==0){return false;}return true;}
function compareDates(date1,dateformat1,date2,dateformat2){var d1=getDateFromFormat(date1,dateformat1);var d2=getDateFromFormat(date2,dateformat2);if(d1==0 || d2==0){return -1;}else if(d1 > d2){return 1;}return 0;}
function formatDate(date,format){format=format+"";var result="";var i_format=0;var c="";var token="";var y=date.getYear()+"";var M=date.getMonth()+1;var d=date.getDate();var E=date.getDay();var H=date.getHours();var m=date.getMinutes();var s=date.getSeconds();var yyyy,yy,MMM,MM,dd,hh,h,mm,ss,ampm,HH,H,KK,K,kk,k;var value=new Object();if(y.length < 4){y=""+(y-0+1900);}value["y"]=""+y;value["yyyy"]=y;value["yy"]=y.substring(2,4);value["M"]=M;value["MM"]=LZ(M);value["MMM"]=MONTH_NAMES[M-1];value["NNN"]=MONTH_NAMES[M+11];value["d"]=d;value["dd"]=LZ(d);value["E"]=DAY_NAMES[E+7];value["EE"]=DAY_NAMES[E];value["H"]=H;value["HH"]=LZ(H);if(H==0){value["h"]=12;}else if(H>12){value["h"]=H-12;}else{value["h"]=H;}value["hh"]=LZ(value["h"]);if(H>11){value["K"]=H-12;}else{value["K"]=H;}value["k"]=H+1;value["KK"]=LZ(value["K"]);value["kk"]=LZ(value["k"]);if(H > 11){value["a"]="PM";}else{value["a"]="AM";}value["m"]=m;value["mm"]=LZ(m);value["s"]=s;value["ss"]=LZ(s);while(i_format < format.length){c=format.charAt(i_format);token="";while((format.charAt(i_format)==c) &&(i_format < format.length)){token += format.charAt(i_format++);}if(value[token] != null){result=result + value[token];}else{result=result + token;}}return result;}
function _isInteger(val){var digits="1234567890";for(var i=0;i < val.length;i++){if(digits.indexOf(val.charAt(i))==-1){return false;}}return true;}
function _getInt(str,i,minlength,maxlength){for(var x=maxlength;x>=minlength;x--){var token=str.substring(i,i+x);if(token.length < minlength){return null;}if(_isInteger(token)){return token;}}return null;}
function getDateFromFormat(val,format){val=val+"";format=format+"";var i_val=0;var i_format=0;var c="";var token="";var token2="";var x,y;var now=new Date();var year=now.getYear();var month=now.getMonth()+1;var date=1;var hh=now.getHours();var mm=now.getMinutes();var ss=now.getSeconds();var ampm="";while(i_format < format.length){c=format.charAt(i_format);token="";while((format.charAt(i_format)==c) &&(i_format < format.length)){token += format.charAt(i_format++);}if(token=="yyyy" || token=="yy" || token=="y"){if(token=="yyyy"){x=4;y=4;}if(token=="yy"){x=2;y=2;}if(token=="y"){x=2;y=4;}year=_getInt(val,i_val,x,y);if(year==null){return 0;}i_val += year.length;if(year.length==2){if(year > 70){year=1900+(year-0);}else{year=2000+(year-0);}}}else if(token=="MMM"||token=="NNN"){month=0;for(var i=0;i<MONTH_NAMES.length;i++){var month_name=MONTH_NAMES[i];if(val.substring(i_val,i_val+month_name.length).toLowerCase()==month_name.toLowerCase()){if(token=="MMM"||(token=="NNN"&&i>11)){month=i+1;if(month>12){month -= 12;}i_val += month_name.length;break;}}}if((month < 1)||(month>12)){return 0;}}else if(token=="EE"||token=="E"){for(var i=0;i<DAY_NAMES.length;i++){var day_name=DAY_NAMES[i];if(val.substring(i_val,i_val+day_name.length).toLowerCase()==day_name.toLowerCase()){i_val += day_name.length;break;}}}else if(token=="MM"||token=="M"){month=_getInt(val,i_val,token.length,2);if(month==null||(month<1)||(month>12)){return 0;}i_val+=month.length;}else if(token=="dd"||token=="d"){date=_getInt(val,i_val,token.length,2);if(date==null||(date<1)||(date>31)){return 0;}i_val+=date.length;}else if(token=="hh"||token=="h"){hh=_getInt(val,i_val,token.length,2);if(hh==null||(hh<1)||(hh>12)){return 0;}i_val+=hh.length;}else if(token=="HH"||token=="H"){hh=_getInt(val,i_val,token.length,2);if(hh==null||(hh<0)||(hh>23)){return 0;}i_val+=hh.length;}else if(token=="KK"||token=="K"){hh=_getInt(val,i_val,token.length,2);if(hh==null||(hh<0)||(hh>11)){return 0;}i_val+=hh.length;}else if(token=="kk"||token=="k"){hh=_getInt(val,i_val,token.length,2);if(hh==null||(hh<1)||(hh>24)){return 0;}i_val+=hh.length;hh--;}else if(token=="mm"||token=="m"){mm=_getInt(val,i_val,token.length,2);if(mm==null||(mm<0)||(mm>59)){return 0;}i_val+=mm.length;}else if(token=="ss"||token=="s"){ss=_getInt(val,i_val,token.length,2);if(ss==null||(ss<0)||(ss>59)){return 0;}i_val+=ss.length;}else if(token=="a"){if(val.substring(i_val,i_val+2).toLowerCase()=="am"){ampm="AM";}else if(val.substring(i_val,i_val+2).toLowerCase()=="pm"){ampm="PM";}else{return 0;}i_val+=2;}else{if(val.substring(i_val,i_val+token.length)!=token){return 0;}else{i_val+=token.length;}}}if(i_val != val.length){return 0;}if(month==2){if( ((year%4==0)&&(year%100 != 0) ) ||(year%400==0) ){if(date > 29){return 0;}}else{if(date > 28){return 0;}}}if((month==4)||(month==6)||(month==9)||(month==11)){if(date > 30){return 0;}}if(hh<12 && ampm=="PM"){hh=hh-0+12;}else if(hh>11 && ampm=="AM"){hh-=12;}var newdate=new Date(year,month-1,date,hh,mm,ss);return newdate.getTime();}
function parseDate(val){var preferEuro=(arguments.length==2)?arguments[1]:false;generalFormats=new Array('y-M-d','MMM d, y','MMM d,y','y-MMM-d','d-MMM-y','MMM d');monthFirst=new Array('M/d/y','M-d-y','M.d.y','MMM-d','M/d','M-d');dateFirst =new Array('d/M/y','d-M-y','d.M.y','d-MMM','d/M','d-M');var checkList=new Array('generalFormats',preferEuro?'dateFirst':'monthFirst',preferEuro?'monthFirst':'dateFirst');var d=null;for(var i=0;i<checkList.length;i++){var l=window[checkList[i]];for(var j=0;j<l.length;j++){d=getDateFromFormat(val,l[j]);if(d!=0){return new Date(d);}}}return null;}
